# Don't use fakeroot
%define srcversion 2.2.15
%define kversion 2.2.15
%define pcmciaver 3.1.14
%define pcmciadate 14-Jan-00
%define ibcsver 2.1-981105
%define ksymoopsver 2.3.3
%define krelease 4mdk
%define alsaver 0.5.7
%define emu10date 030600
%define lfs 0
%define KVERREL %{kversion}-%{krelease}
%define reiserfsver 3.5.19

Summary: The Linux kernel (the core of the Linux operating system).
Name: kernel
Version: %{kversion}
Release: %{krelease}
Copyright: GPL
Group: System/Kernel and hardware
ExclusiveArch: i386 i486 i586 i686 k6 alpha sparc sparc64
ExclusiveOS: Linux
Obsoletes: kernel-modules, kernel-sparc alsa-driver alsa-dev

Source0: ftp://ftp.kernel.org/pub/linux/kernel/v2.2/linux-%{srcversion}.tar.bz2
Source1: ftp://sourceforge.org/pcmcia/NEW/pcmcia-cs-%{pcmciaver}.tar.bz2
Source2: ftp://tsx-11.mit.edu/pub/linux/BETA/ibcs2/ibcs-%{ibcsver}.tar.bz2
Source4: README.kernel-sources
Source5: ftp://ftp.ocs.com.au/pub/ksymoops/ksymoops-%{ksymoopsver}.tar.bz2
Source7: ftp://ftp.alsa-project.org/pub/driver/alsa-driver-%{alsaver}.tar.bz2

Source10: pcmcia-cs-2.8.8-network.script
Source13: rhkmvtag.c
Source14: kernel-2.2-BuildASM.sh
Source15: linux-autoconf.h
Source16: linux-version.h
Source17: linux-modversions.h
Source18: kernel.xpm

# Be carrefull Source20 it's the _default_ Source for all kernel
Source20: kernel-%{kversion}-i586.config
Source21: kernel-%{kversion}-i586-fb.config
Source23: kernel-%{kversion}-i586-smp.config
Source24: kernel-%{kversion}-i586-secure.config

# Sparc
Source27: kernel-%{kversion}-sparc64.config
Source28: kernel-%{kversion}-sparc64-smp.config
Source29: kernel-%{kversion}-sparc64-secure.config

# Alpha
Source23: kernel-%{kversion}-alpha.config
Source24: kernel-%{kversion}-alpha-smp.config
Source24: kernel-%{kversion}-alpha-secure.config

# k6 config's files - SMP is not needed for k6
Source42: kernel-2.2-k6.config
Source44: kernel-2.2-k6-fb.config

# Secure version of our kernel.
Source70: http://www.openwall.com/linux/linux-2.2.15-ow2.tar.bz2

# Emu10k1: CVSROOT=:pserver:cvsguest@opensource.creative.com:/usr/local/cvsroot
Source71: emu10k1-%{emu10date}.tar.bz2

# i810 from XFree86 sources
Source72: i810.tar.bz2

# Sock again
Patch11: kernel-2.2.15pre12-smbsock.patch.bz2
Patch12: kernel-2.2.15pre12-usbsock.patch.bz2
Patch13: kernel-2.2.15pre15-typo.patch.bz2
Patch14: kernel-2.2.15pre15-ipmasq_security.patch.bz2

# IDE driver # We can't aplly it yet, too many cdrom broken.
Patch15: ftp://ftp.us.kernel.org/pub/linux/kernel/people/henrick/ide.2.2.15-19.20000420.patch.bz2

# Updates.
Patch20: ibcs-2.1-rh.patch.bz2
Patch21: pcmcia-cs-3.1.9-script.patch.bz2
Patch22: pcmcia-cs-3.1.4-xircom.patch.bz2
Patch23: pcmcia-cs-3.1.3-3com.patch.bz2
Patch24: ipvs-0.9.11-2.2.14.patch.bz2
Patch25: linux-2.2.12-ipvsfix.patch.bz2
Patch26: http://people.redhat.com/dledford/aic7xxx-5.1.29.patch.bz2

# Supermount
Patch36: http://supermount.cornpops.cx/supermount-0.1.5-2.2.14.diff.bz2
Source73: http://supermount.cornpops.cx/supermount.README.txt
Patch37: kernel-2.2.15-uglypatch-supermount.patch.bz2


# RedHat stuff
Patch111: raw-2.2.13-rh61.diff.bz2
Patch113: linux-2.2.12-symversion.patch.bz2
Patch114: raid-2.2.14-B1.bz2
Patch116: linux-2.2.12-limits.patch.bz2
Patch117: linux-2.2.12-3c90x.patch.bz2
Patch118: linux-2.2.13-alphamsnd.patch.bz2
Patch121: linux-2.2.14-lfs-headers.patch.bz2
Patch122: linux-2.2.14-lfs.patch.bz2
Patch123: linux-2.2.12-PIII.patch.bz2
Patch124: linux-2.2.12-PIII-xor.patch.bz2
Patch126: linux-2.2.14-alpha-ramdisk.patch.bz2
Patch127: linux-2.2.14-sigio.patch.bz2
Patch129: linux-2.2.14-nobfddep.patch.bz2
Patch130: linux-2.2.14-iobuffix.patch.bz2
Patch131: linux-2.2.14-sunpartshaddap.patch.bz2
Patch132: linux-2.2.14-nfsattack2.patch.bz2
Patch133: linux-2.2.14-sparc-nfs.patch.bz2
Patch134: linux-2.2.14-fb-modules.patch.bz2
#  Patch135: linux-2.2.14-moremaestro.patch.bz2
#  Patch136: linux-2.2.14-timersync.patch.bz2
#  Patch137: linux-2.2.14-MegaRAID.patch.bz2
#  Patch138: linux-2.2.13-aic7xxx-5.1.22.patch.bz2
#  Patch139: linux-2.2.13-aic7xxx-5.1.23.patch.bz2
#  Patch140: linux-2.2.13-aic7xxx-5.1.24.patch.bz2
#  Patch141: linux-2.2.13-aic7xxx-5.1.25.patch.bz2
#  Patch142: linux-2.2.14-blkdev.patch.bz2
#  Patch143: linux-2.2.14-alpha-exception.patch.bz2
#  Patch144: linux-2.2.14-82596-crash.patch.bz2
#  Patch145: linux-2.2.14-cyclades-smp.patch.bz2
#  Patch146: linux-2.2.14-duh.patch.bz2
#  Patch147: linux-2.2.14-eepro100.patch.bz2
#  Patch148: linux-2.2.14-elf-loader.patch.bz2
#  Patch149: linux-2.2.14-i386-asm.patch.bz2
#  Patch150: linux-2.2.14-ide-probe.patch.bz2
#  Patch151: linux-2.2.14-lucent-hang.patch.bz2
#  Patch152: linux-2.2.14-mediaGX.patch.bz2
#  Patch153: linux-2.2.14-msdos-fixup.patch.bz2
#  Patch154: linux-2.2.14-nfs-fix.patch.bz2
#  Patch155: linux-2.2.14-oom-hang.patch.bz2
#  Patch156: linux-2.2.14-plip-fix.patch.bz2
#  Patch157: linux-2.2.14-rpc.patch.bz2
#  Patch158: linux-2.2.14-scsi-blacklist.patch.bz2
#  Patch159: linux-2.2.14-shmem-overwrite.patch.bz2
#  Patch160: linux-2.2.14-sigkill.patch.bz2
#  Patch161: linux-2.2.14-sound-update.patch.bz2
#  Patch162: linux-2.2.14-bonding.patch.bz2
#  Patch163: linux-2.2.14-network-fixes.patch.bz2
#  Patch164: linux-2.2.14-sparc-fixes.patch.bz2
# Patch165: linux-2.2.14-megaraid.patch.bz2
Patch166: linux-2.2.14-loop.patch.bz2
Patch168: linux-2.2.14-acenic041.patch.bz2
Patch169: linux-2.2.14-nochangeprintk.patch.bz2
Patch170: linux-2.2.15-bigmem-no-lfs.patch.bz2
Patch171: linux-2.2.13-bigmem.patch.bz2
Patch172: linux-2.2.13-bigmem-dcache.patch.bz2
Patch173: linux-2.2.12-bigmem-raw.patch.bz2
Patch174: linux-2.2.12-bigmem-initrd.patch.bz2
Patch180: linux-2.2.14-newagpdist.patch.bz2
Patch181: linux-2.2.14-agphjlfixes.patch.bz2

# SuSE stuff
Patch200: ibmtr-2.2.10.bz2
Patch202: SMP-scheduler-2.2.11-E.bz2
Patch203: bttv-2.2.12.bz2
Patch204: dc390-20d-20d23.diff.bz2
Patch205: dc395-111.diff.bz2
Patch206: nfs-inode-2.2.10.bz2
Patch207: no-swapout-2.2.10-B.bz2
Patch208: rl100-2.2.10.bz2
Patch209: shrink_all_cache-2.2.10-A.bz2
Patch210: alpha_initrd_fixes.bz2

#USB backport.
Patch300: http://www.suse.cz/development/usb-backport/usb-2.3.99-pre7-1-for-2.2.14.diff.bz2

#UDF
Patch310: udf-2.2.14-2.diff.bz2

#Reiserfs
Patch315: linux-2.2.14-reiserfs-%{reiserfsver}-patch.bz2
Patch316: linux-2.2.15pre15-reiseirfs-symlink.patch.bz2
Patch317: linux-2.2.15pre15-reiseirfs-force.patch.bz2
Patch318: linux-3.5.19-reiserfs-version-patch.bz2

#Bigmem
Patch320: ftp://ftp.kernel.org/pub/linux/kernel/people/andrea/kernels/v2.2/2.2.15aa1/bigmem-2.2.15-9.bz2
Patch321: ftp://ftp.kernel.org/pub/linux/kernel/people/andrea/kernels/v2.2/2.2.15aa1/bigmem-large-shm-1.bz2

# Misc
Patch401: linux-linuxlogo.patch.bz2
Patch402: pcmcia-cs-3.1.14-install-man.patch.bz2
Patch10: linux-2.2.15pre7-revertraid1.patch.bz2

BuildRoot: %{_tmppath}/kernel-%{KVERREL}-root
Provides: module-info
Autoreqprov: no
Prereq: initscripts, /usr/sbin/rdev

%package source
Requires: kernel-headers = %{kversion}-%{krelease}, glibc-devel, ncurses-devel, make, gcc, bin86
Summary: The source code for the Linux kernel.
Group: Development/Kernel

%package -n alsa
Requires: kernel = %{kversion}-%{krelease}, modutils >= 2.3.9
Summary: Advanced Linux Sound Architecture (ALSA) drivers
Group: System/Kernel and hardware
Version: %{alsaver}
Obsoletes: alsa-driver

%package -n alsa-source
Requires: kernel-headers, glibc-devel, ncurses-devel, make, gcc, bin86
Summary: The Advanced Linux Sound Architecture (ALSA) source.
Group: Development/Kernel
Version: %{alsaver}

%ifarch i386 i486 i586 i686 k6 k7
%package -n reiserfs-utils
Summary: The utilities to create Reiserfs volume.
Group: System/Kernel and hardware
Version: %{reiserfsver}
%endif

%package headers
Summary: Header files for the Linux kernel.
Group: Development/Kernel

%package doc
Summary: Various documentation bits found in the kernel source.
Group: Development/Kernel

%package pcmcia-cs
Summary: The daemon and device drivers for using PCMCIA adapters.
Group: System/Kernel and hardware
Obsoletes: pcmcia-cs

%package utils
Summary: Kernel related utilities.
Group: System/Kernel and hardware

%package ibcs
Obsoletes: iBCS
Summary: Files which allow iBCS2 programs to run.
Group: System/Kernel and hardware

%description
The kernel package contains the Linux kernel (vmlinuz), the core of your
Linux Mandrake operating system.  The kernel handles the basic functions
of the operating system:  memory allocation, process allocation, device
input and output, etc.

%description source
The kernel-source package contains the source code files for the Linux
kernel. These source files are needed to build most C programs, since
they depend on the constants defined in the source code. The source
files can also be used to build a custom kernel that is better tuned to
your particular hardware, if you are so inclined (and you know what you are
doing).

%description headers
Kernel-headers includes the C header files for the Linux kernel.  The
header files define structures and constants that are needed for building
most standard programs.  The header files are also needed for rebuilding
the kernel.

%description doc
This package contains documentation files form the kernel source. Various
bits of information about the Linux kernel and the device drivers shipped
with it are documented in these files. You also might want install this
package if you need a reference to the options that can be passed to Linux
kernel modules at load time.

%description pcmcia-cs
Many laptop machines (and some non-laptops) support PCMCIA cards for
expansion. Also known as "credit card adapters," PCMCIA cards are small
cards for everything from SCSI support to modems. PCMCIA cards are hot
swappable (i.e., they can be exchanged without rebooting the system) and
quite convenient to use. The kernel-pcmcia-cs package contains a set of
loadable kernel modules that implement an applications program interface,
a set of client drivers for specific cards and a card manager daemon that
can respond to card insertion and removal events by loading and unloading
drivers on demand.  The daemon also supports hot swapping, so that the
cards can be safely inserted and ejected at any time.

Install the kernel-pcmcia-cs package if your system uses PCMCIA cards.

%description utils
The kernel-utils package contains ksymoops, a utility that can be used
for decrypting the kernel's OOPS output.

%description ibcs
This package allows you to run programs in the iBCS2 (Intel Binary
Compatibility Standard, version 2) and related executable formats. 
iBCS is a standard for binary portability between UNIX and UNIX-like
systems.

%description -n alsa
Advanced Linux Sound Architecture (ALSA) drivers. Modularized architecture with
support for a large range of ISA and PCI cards. Fully compatible with OSS/Lite
(kernel sound drivers), but contains many enhanced features.

This rpm is compiled for default up kernel if you want to use for
others kernel recompile the source from alsa-source.

%ifarch i386 i486 i586 i686 k6 k7
%description -n reiserfs-utils
Reiserfs is a file system using a plug-in based object oriented
variant on classical balanced tree algorithms. The results when
compared to the ext2fs conventional block allocation based file system
running under the same operating system and employing the same
buffering code suggest that these algorithms are overall more
efficient, and are becoming more so every passing month.  Loosely
speaking, every month we find another performance cranny that needs
work, and we fix it, and every month we find some way of improving our
overall general usage performance. The improvement in small file space
and time performance suggests that we may now revisit a common OS
design assumption that one should aggregate small objects using layers
above the file system layer. Being more effective at small files DOES
NOT make us less effective for other files, this is a general purpose
FS, and our overall traditional FS usage performance is high enough to
establish that. Reiserfs has a commitment to opening up the FS design
to contributions, and we are now now adding plug-ins so that you can
create your own types of directories and files.
%endif

%description -n alsa-source
Advanced Linux Sound Architecture (ALSA) drivers. Modularized architecture with
support for a large range of ISA and PCI cards. Fully compatible with OSS/Lite
(kernel sound drivers), but contains many enhanced features.

This rpm is the source of alsa use it to fit your alsa modules to the kernel.

%package smp
Summary: The Linux Kernel compiled for SMP machines.
Group: System/Kernel and hardware
Provides: kernel = %{kversion}, kernel-smp-fb
Obsoletes: kernel-smp-fb
Prereq: /sbin/installkernel, /usr/sbin/rdev

%description smp
This package includes a SMP version of the Linux %{kversion} kernel. It is
required only on machines with two or more CPUs, although it should work
fine on single-CPU boxes.

%package fb
Summary: Kernel version %{kversion} with framebuffer support
Group: System/Kernel and hardware
Provides: kernel = %{kversion}
Prereq: /sbin/installkernel, /usr/sbin/rdev

%description fb
This package includes a version of the Linux %{kversion} kernel
with framebuffer support.

%package secure
Summary: The secure version of Linux-Kernel.
Group: System/Kernel and hardware
Provides: kernel = %{kversion}
Prereq: /sbin/installkernel, /usr/sbin/rdev

%description secure
The Secure-Linux patch adds a few security features to the kernel
which, while not a complete method of protection, will stop most of
the 'cookbook' buffer overflow exploits cold. It also adds the option
of restricting the use of symlinks in +t (temp) directories which
fixes most tmp-race exploits as well. It can also add a little bit
more privacy to the system by restricting access to parts of /proc to
root so that users may not see who else is logged on or what they are
doing.

%prep
%ifarch i386 i486 i586 i686 k6 k7
%setup -q -n linux -a 1 -a 2 -a 5 -a 7 -a 71 -a 72
%else
%setup -q -n linux -a 1 -a 2 -a 5
%endif

# push in Mandrake bootlogo
#  %ifarch sparc sparc64
#  bzcat %{SOURCE20} > include/asm-sparc64/linux_logo.h
#  %endif

#IDE
%patch15 -p1

# Revert raid1 patch.
%patch10 -p0

# RedHat
%patch111 -p1
%patch113 -p1
%patch114 -p1
%patch116 -p1
%patch117 -p1
%patch118 -p1
%patch121 -p1
%if %{lfs}
%patch122 -p1
%endif
%patch126 -p1
%patch127 -p1
%patch129 -p1
%patch130 -p1
%patch131 -p1
%patch133 -p1
%patch134 -p1
%patch166 -p0
%ifarch i386 i486 i586 i686 k6 k7
#%patch180 -p1
#%patch181 -p1
%endif

# PCMCIA, IBCS
%ifarch i386 i486 i586 i686 k6 k7
%patch20 -p0
cd pcmcia-cs-%{pcmciaver}
%patch21 -p1
%patch22 -p2
%patch23 -p2
%patch402 -p1
find ./etc/ -perm 0555|xargs chmod 0755
cd ..
cp ibcs/CONFIG.i386 ibcs/CONFIG
%else
rm -rf pcmcia-cs-%{pcmciaver}
rm -rf ibcs
%endif

# IPVS stuff for HA
%patch24 -p1
%patch25 -p1

#AIC7 upgrade
%patch26 -p1

# Suse
%patch200 -p1
%patch202 -p1
%patch203 -p1
%patch204 -p1
%patch205 -p1
%patch206 -p1
%patch207 -p1
%patch208 -p1
%patch209 -p1

%patch210 -p0

%ifnarch sparc
# Supermount
%patch36 -p1
%patch37 -p1
%patch169 -p1

# USB backport.
%patch300 -p1
%endif

# Fix new sigio of socket with our driver.
%patch11 -p0
%ifnarch sparc
%patch12 -p0
%endif

%ifnarch sparc
# Udf support
%patch310 -p1
%endif

%ifarch i386 i486 i586 i686 k6 k7
#Reiserfs
%patch315 -p1
%patch316 -p1
%patch317 -p1
%patch318 -p1
%endif

%patch320 -p1
%patch321 -p1

%patch13 -p1
%patch401 -p1

# Bring in the MandrakeKernel Module Version Tag program
cp $RPM_SOURCE_DIR/rhkmvtag.c .

# ship more recent version of ksysmoops
rm -rf scripts/ksymoops/
mv ksymoops-%{ksymoopsver} scripts/ksymoops

# get rid of unwanted files
find . -name '*~' -o -name '*.orig'|xargs rm -f

###
### build
###

%build
if [ -z "$NRPROC" ]; then 
if [ -x /usr/bin/getconf ] ; then
    NRPROC=$(/usr/bin/getconf _NPROCESSORS_ONLN)
    if [ $NRPROC -eq 0 ] ; then
	NRPROC=1
    fi
else
    NRPROC=1
fi
fi

BuildKernel() {
    # is this a special kernel we want to build?
    if [ -n "$1" ] ; then
	Config=%{_target_cpu}-$1
	KernelVer=%{kversion}-%{krelease}$1
	echo BUILDING A KERNEL FOR $1...
    else
	Config=%{_target_cpu}
	KernelVer=%{kversion}-%{krelease}
	echo BUILDING THE NORMAL KERNEL...
    fi

%ifarch sparc64
    cp $RPM_SOURCE_DIR/kernel-%{kversion}-$Config.config arch/%{_target_cpu}/defconfig
%else
    cp $RPM_SOURCE_DIR/kernel-%{kversion}-$Config.config arch/%{_arch}/defconfig
%endif
    rm -f .config
    # make sure EXTRAVERSION says what we want it to say
    perl -p -i -e "s/^EXTRAVERSION.*/EXTRAVERSION = -%{krelease}$1/" Makefile
	# Build with CFLAGS
    perl -p -i -e "s/^HOSTCFLAGS.*/HOSTCFLAGS = $RPM_OPT_FLAGS/" Makefile
    perl -p -i -e "s/^CFLAGS_NSR.*/CFLAGS_NSR := $RPM_OPT_FLAGS/" arch/%{_arch}/Makefile

%ifarch i386 i486 i586 i686 k6 k7
    cd i810
    make clean
    cd ..
%endif
    make mrproper
    make oldconfig

	cmp -s .config $RPM_SOURCE_DIR/kernel-%{kversion}-$Config.config || \
		   cp -vf .config $RPM_SOURCE_DIR/kernel-%{kversion}-$Config.config

    make dep
    make include/linux/version.h 
%ifarch i386 i486 i586 i686 k6 k7
    cd i810
    make
    cd ..
    make -j $NRPROC bzImage MAKE="make -j $NRPROC" || \
	make bzImage
%else
    make -j $NRPROC boot MAKE="make -j $NRPROC" || make boot
%endif
    make -j $NRPROC modules MAKE="make -j $NRPROC" || \
	make modules
    find include/linux/modules -size 0 | while read file ; do \
	echo > $file
    done
    mkdir -p $RPM_BUILD_ROOT/boot
    install -m 644 System.map $RPM_BUILD_ROOT/boot/System.map-$KernelVer
%ifarch i386 i486 i586 i686 k6 k7
    cp arch/i386/boot/bzImage $RPM_BUILD_ROOT/boot/vmlinuz-$KernelVer
%else
    gzip -cfv vmlinux > vmlinuz
    install -m 755 vmlinux $RPM_BUILD_ROOT/boot/vmlinux-$KernelVer
    install -m 644 vmlinuz $RPM_BUILD_ROOT/boot/vmlinuz-$KernelVer
%endif
    mkdir -p $RPM_BUILD_ROOT/lib/modules/$KernelVer/{block,cdrom,fs,ipv4,misc,net,scsi,video}
    make INSTALL_MOD_PATH=$RPM_BUILD_ROOT modules_install KERNELRELEASE=$KernelVer
%ifarch i386 i486 i586 i686 k6 k7
    install i810/agpgart.o $RPM_BUILD_ROOT/lib/modules/$KernelVer/misc/
%endif
%ifnarch sparc64
    cc -o rhkmvtag rhkmvtag.c init/version.o
    ./rhkmvtag > $RPM_BUILD_ROOT/lib/modules/$KernelVer/.rhkmvtag
    rm -f rhkmvtag
%endif
}

BuildiBCS() {
    if [ -z "$2" ] ; then
	echo "BUILDING FOR NORMAL KERNEL..."
    else
	echo "BUILDING FOR $2..."
    fi
    make -j $NRPROC -C ibcs/iBCSemul KERNEL=$RPM_BUILD_DIR/linux SMP=$1 all
	mkdir -p $RPM_BUILD_ROOT/lib/modules/%{KVERREL}$2/misc/
    install -m644 ibcs/iBCSemul/iBCS \
	$RPM_BUILD_ROOT/lib/modules/%{KVERREL}$2/misc/iBCS.o
    make -C ibcs clean 
}


BuildPCMCIA() {
    if [ -z "$1" ] ; then
	echo "BUILDING FOR NORMAL KERNEL..."
    else
	echo "BUILDING FOR $1..."
    fi

    make -C pcmcia-cs-%{pcmciaver} config <<EOF
$RPM_BUILD_DIR/linux
$RPM_BUILD_ROOT
y
y
n
/lib/modules/%{KVERREL}$1
y
/etc/rc.d
EOF
    make -j $NRPROC MAKE="make -j $NRPROC" -C pcmcia-cs-%{pcmciaver} all
    mkdir -p $RPM_BUILD_ROOT/lib/modules/%{KVERREL}$1/pcmcia
    make -C pcmcia-cs-%{pcmciaver} install
	rm -f pcmcia-cs-%{pcmciaver}/config.out
}

SaveHeaders() {
    if [ -n "$1" ] ; then
	echo "SAVING HEADERS for $1"
    fi
    # deal with the kernel headers that are version specific
    mkdir -p $RPM_BUILD_ROOT/usr/src/linux-%{kversion}/include/linux
    if [ -n "$1" ] ; then
    	install -m 644 include/linux/autoconf.h \
	    $RPM_BUILD_ROOT/usr/src/linux-%{kversion}/include/linux/autoconf-$1.h
    	install -m 644 include/linux/version.h \
	    $RPM_BUILD_ROOT/usr/src/linux-%{kversion}/include/linux/version-$1.h
	sed -e "s,/modules/,/modules-$1/,g" < include/linux/modversions.h > \
	    $RPM_BUILD_ROOT/usr/src/linux-%{kversion}/include/linux/modversions-$1.h
	mv include/linux/modules include/linux/modules-$1
    fi
%ifarch i386 i486 i586 i686 k6 k7
    install -m 644 i810/agpgart.h $RPM_BUILD_ROOT/usr/src/linux-%{kversion}/include/linux/
%endif
}

BuildAlsa() {
	c=$1
	echo "Building for $c"

   	pushd alsa-driver-%{alsaver}  && {

	[ -e Makefile.conf ] && make mrproper

	CFLAGS=$RPM_OPT_FLAGS ./configure --with-kernel=$RPM_BUILD_DIR/linux \
        --with-moddir=$RPM_BUILD_ROOT/lib/modules/%{KVERREL}$c/alsa/ \
	--with-processor=%{_target_cpu} --with-smp=auto --with-isapnp --with-sequencer=yes \
	--with-oss=yes
	make all

	mkdir -p $RPM_BUILD_ROOT/lib/modules/%{KVERREL}$c/alsa/
	install -m644 modules/*.o $RPM_BUILD_ROOT/lib/modules/%{KVERREL}$c/alsa/

    } && popd
}

BuildSB() {
		pushd emu10k1 && {
		make all KERNELSOURCE=../ && \
		mkdir -p $RPM_BUILD_ROOT/lib/modules/%{KVERREL}$1/misc && \
		install -m644 emu10k1.o $RPM_BUILD_ROOT/lib/modules/%{KVERREL}$1/misc/
		make clean KERNELSOURCE=../
		} && popd 
}

BuildSecure () {
    bzcat %{SOURCE70}|tar xv
    patch -p1 < linux-2.2.15-ow2/linux-2.2.15-ow2.diff
    cp arch/%{_arch}/defconfig arch/%{_arch}/defconfig.secureorig
    BuildKernel secure
%ifarch i386 i486 i586 i686 k6 k7
	BuildSB secure
    BuildiBCS no secure
    BuildPCMCIA secure
%endif
    SaveHeaders secure
    mv arch/%{_arch}/defconfig.secureorig arch/%{_arch}/defconfig
    patch -R -p1 < linux-2.2.15-ow2/linux-2.2.15-ow2.diff
    mkdir -p Documentation/secure/
    install -m644 linux-2.2.15-ow2/*.c Documentation/secure/
    install -m644 linux-2.2.15-ow2/README Documentation/secure/README.secure
    find|grep "~$"|xargs rm -f
}

###
# DO it...
###
rm -rf $RPM_BUILD_ROOT

#Secure Kernel, slighty different of others.
BuildSecure

#SMP-ENABLED KERNEL
# k6 can't be SMP
%ifnarch k6
		BuildKernel smp
%ifarch i386 i486 i586 i686
		BuildAlsa smp
		BuildiBCS yes smp
		BuildPCMCIA smp
		BuildSB smp
%endif
	SaveHeaders smp
%endif

%ifarch i386 i486 i586 i686 k6 k7
		# FB KERNEL
		BuildKernel fb
		BuildAlsa fb
		BuildiBCS no fb
		BuildPCMCIA fb
		BuildSB fb
		SaveHeaders fb
%endif

# NORMAL KERNEL
BuildKernel
%ifarch i386 i486 i586 i686 k6
BuildAlsa
BuildSB
BuildiBCS no
BuildPCMCIA
%endif
SaveHeaders up

make -C scripts/ksymoops/

%ifarch i386 i486 i586 i686 k6 k7
make -C fs/reiserfs/utils/
%endif

###
### install
###

%install
mkdir -p $RPM_BUILD_ROOT/{boot,sbin}

%ifarch sparc
mv -f Makefile.sparcsuck Makefile
%endif

mkdir -p $RPM_BUILD_ROOT/{sbin,usr/man/man8}
%ifarch i386 i486 i586 i686 k6 k7
make  -C fs/reiserfs/utils SBIN=$RPM_BUILD_ROOT/sbin install MANDIR=$RPM_BUILD_ROOT/usr/man/man8/ 
(cd $RPM_BUILD_ROOT/sbin; ln -s ../bin/true $RPM_BUILD_ROOT/sbin/fsck.reiserfs)
%endif

# Install config files.
mkdir -p config_files/
for i in $RPM_SOURCE_DIR/*%{_target_cpu}*config;do
	n=$(basename $i|sed 's/%{kversion}/%{KVERREL}/')
    install -m644 $i config_files/$n
done

%ifnarch sparc sparc32
#Supermount README
install -m644 %{SOURCE73} Documentation/
%endif

%ifarch i386 i486 i586 i686 k6
#Install Alsa documentation
rm -rf alsa-doc/
mkdir -p alsa-doc/
for i in COPYING INSTALL FAQ README README.kernel doc/SOUNDCARDS WARNING;do
    install -m644 alsa-driver-%{alsaver}/$i alsa-doc/
done

#Install Emu10k1 documentation
mkdir -p Documentation/emu10k1
for i in emu10k1/GNU_GPL emu10k1/docs/*;do
install -m644 $i Documentation/emu10k1/
done

# Install header of alsa
mkdir -p $RPM_BUILD_ROOT/usr/src/linux/include/linux
for i in asound.h asoundid.h asequencer.h ainstr_simple.h ainstr_gf1.h ainstr_iw.h;do
 install -m644 alsa-driver-%{alsaver}/include/$i \
		$RPM_BUILD_ROOT/usr/src/linux-%{kversion}/include/linux/
done

%endif

# /Includes links.
mkdir -p $RPM_BUILD_ROOT/usr/include
ln -sf ../src/linux/include/linux $RPM_BUILD_ROOT/usr/include/linux

mkdir -p $RPM_BUILD_ROOT/usr/src/linux-%{kversion} 

#this is kind of ugly, but have asked for it
touch /boot/kernel.h || :

%ifarch i386 i486 i586 i686 k6  k7
mkdir -p $RPM_BUILD_ROOT/etc/pcmcia
mkdir -p $RPM_BUILD_ROOT/etc/sysconfig

# Install our own network up/down script
install -m755 $RPM_SOURCE_DIR/pcmcia-cs-2.8.8-network.script \
        $RPM_BUILD_ROOT/etc/pcmcia/network

# We need our own default /etc/sysconfig/pcmcia
cat > $RPM_BUILD_ROOT/etc/sysconfig/pcmcia <<EOF
PCMCIA=no
PCIC=
PCIC_OPTS=
CORE_OPTS=
EOF

# iBCS stuff
mkdir -p $RPM_BUILD_ROOT/usr/man/man9
install -m 644 ibcs/Doc/iBCS.9 $RPM_BUILD_ROOT/usr/man/man9

mkdir -p $RPM_BUILD_ROOT/dev/inet
install -m755 ibcs/MAKEDEV.ibcs $RPM_BUILD_ROOT/dev/MAKEDEV.ibcs
pushd $RPM_BUILD_ROOT ; {
# Tricky way to permit rpm -bi --short-circuit
 [ -e ./dev/socksys ] || {
  mknod ./dev/socksys c 30 0
  ln -s socksys ./dev/nfsd
  ln -s null ./dev/X0R
  mknod ./dev/spx c 30 1
  mknod ./dev/inet/ip c 30 32
  mknod ./dev/inet/icmp c 30 33
  mknod ./dev/inet/ggp c 30 34
  mknod ./dev/inet/ipip c 30 35
  mknod ./dev/inet/tcp c 30 36
  mknod ./dev/inet/egp c 30 37
  mknod ./dev/inet/pup c 30 38
  mknod ./dev/inet/udp c 30 39
  mknod ./dev/inet/idp c 30 40
  mknod ./dev/inet/rawip c 30 41
  ln -s udp ./dev/inet/arp
  ln -s udp ./dev/inet/rip
  cd ./dev/inet
  for i in *; do
    ln -s inet/$i ../$i
  done
 }
} ; popd
%endif

mkdir -p $RPM_BUILD_ROOT/usr/src/linux-%{kversion}
tar cf - . | tar xf - -C $RPM_BUILD_ROOT/usr/src/linux-%{kversion}
ln -sf linux-%{kversion} $RPM_BUILD_ROOT/usr/src/linux
install -m 644 %{SOURCE4}  $RPM_BUILD_ROOT/usr/src/linux-%{kversion}

# Come from initscripts.
%ifarch i386 i486 i586 i686 k6 k7
( cd $RPM_BUILD_ROOT/usr/src/linux/arch/i386/boot/;ln -sf ../../../../../../sbin/installkernel install.sh)
%endif

%ifarch sparc sparc64
ln -s ../src/linux/include/asm-sparc $RPM_BUILD_ROOT/usr/include/asm-sparc
ln -s ../src/linux/include/asm-sparc64 $RPM_BUILD_ROOT/usr/include/asm-sparc64
mkdir $RPM_BUILD_ROOT/usr/include/asm
install -m755 $RPM_SOURCE_DIR/kernel-2.2-BuildASM.sh $RPM_BUILD_ROOT/usr/include/asm/BuildASM
$RPM_BUILD_ROOT/usr/include/asm/BuildASM $RPM_BUILD_ROOT/usr/include
%else
ln -sf ../src/linux/include/asm $RPM_BUILD_ROOT/usr/include/asm
%endif

# make sure EXTRAVERSION says what we want it to say (in source)
perl -p -i -e "s/^EXTRAVERSION.*/EXTRAVERSION = -%{krelease}/" $RPM_BUILD_ROOT/usr/src/linux-%{kversion}/Makefile

# use the standard i386 config in source
cp %SOURCE20 $RPM_BUILD_ROOT/usr/src/linux-%{kversion}/.config
cp %SOURCE20 $RPM_BUILD_ROOT/usr/src/linux-%{kversion}/arch/i386/defconfig

#clean up the destination
%ifarch i386 i486 i586 i686 k6 k7

make clean -C $RPM_BUILD_ROOT/usr/src/linux-%{kversion}/pcmcia-cs-%{pcmciaver}

#
make -C $RPM_BUILD_ROOT/usr/src/linux-%{kversion}/alsa-driver-%{alsaver} mrproper 
mkdir -p $RPM_BUILD_ROOT/usr/src/drivers/
[ -d $RPM_BUILD_ROOT/usr/src/drivers/alsa-driver-%{alsaver} ] || \
mv $RPM_BUILD_ROOT/usr/src/linux-%{kversion}/alsa-driver-%{alsaver} \
		$RPM_BUILD_ROOT/usr/src/drivers/

#
[ -d $RPM_BUILD_ROOT/usr/src/drivers/emu10k1 ] || \
mv $RPM_BUILD_ROOT/usr/src/linux-%{kversion}/emu10k1 \
		$RPM_BUILD_ROOT/usr/src/drivers/

make -C $RPM_BUILD_ROOT/usr/src/linux-%{kversion}/ibcs clean
%endif

make mrproper -C $RPM_BUILD_ROOT/usr/src/linux-%{kversion}
make oldconfig -C $RPM_BUILD_ROOT/usr/src/linux-%{kversion}
make symlinks -C $RPM_BUILD_ROOT/usr/src/linux-%{kversion}
make include/linux/version.h -C $RPM_BUILD_ROOT/usr/src/linux-%{kversion}

#this generates modversions info which we want to include and we may as
#well include the depends stuff as well, after we fix the paths
make depend -C $RPM_BUILD_ROOT/usr/src/linux-%{kversion}
find $RPM_BUILD_ROOT/usr/src/linux-%{kversion} -name ".*depend" | \
while read file ; do
    mv $file $file.old
    sed -e "s|[^ ]*\(/usr/src/linux\)|\1|g" < $file.old > $file
    rm -f $file.old
done

# Try to put some smarter autoconf.h and version.h files in place
pushd $RPM_BUILD_ROOT/usr/src/linux-%{kversion}/include/linux ; {
#mv autoconf.h autoconf-up.h
#mv version.h version-up.h
#mv modversions.h modversions-up.h
install -m 644 %{SOURCE15} autoconf.h
install -m 644 %{SOURCE16} version.h
install -m 644 %{SOURCE17} modversions.h
} ; popd
> $RPM_BUILD_ROOT/boot/kernel.h

# others tools
mkdir -p $RPM_BUILD_ROOT/usr/{sbin,man/man8}
install -s -m 755 scripts/ksymoops/ksymoops $RPM_BUILD_ROOT/usr/sbin
install -s -m 644 scripts/ksymoops/ksymoops.8 $RPM_BUILD_ROOT/usr/man/man8/
make -C scripts/ksymoops/ clean

mkdir -p $RPM_BUILD_ROOT/usr/lib/menu/
cat << EOF > $RPM_BUILD_ROOT/usr/lib/menu/%{name}-source
?package(%{name}-source): needs="X11" \
 icon="%{name}.xpm" \
 section="Configuration/Other" \
 title="Kernel" longtitle="Kernel Configuration" \
 command="kdesu -c 'cd /usr/src/linux && make xconfig'"
EOF
mkdir -p $RPM_BUILD_ROOT/usr/share/icons/mini/
install -m644 %{SOURCE18} $RPM_BUILD_ROOT/usr/share/icons/mini/%{name}.xpm

###
### clean
###

%clean
rm -rf $RPM_BUILD_ROOT

###
### scripts
###

# do this for upgrades...in case the old modules get removed we have
# loopback in the kernel so that mkinitrd will work.
%pre
/sbin/modprobe loop 2> /dev/null > /dev/null
rm -f /lib/modules/%{KVERREL}/modules.dep
exit 0

%pre smp
/sbin/modprobe loop 2> /dev/null > /dev/null
rm -f /lib/modules/%{KVERREL}smp/modules.dep
exit 0

%pre fb
/sbin/modprobe loop 2> /dev/null > /dev/null
rm -f /lib/modules/%{KVERREL}fb/modules.dep
exit 0

%pre secure
/sbin/modprobe loop 2> /dev/null > /dev/null
rm -f /lib/modules/%{KVERREL}secure/modules.dep
exit 0

%post
cd /boot
ln -sf vmlinuz-%{KVERREL} vmlinuz
ln -sf System.map-%{KVERREL} System.map

%ifarch i386 i486 i586 i686 k6 k7
/sbin/installkernel -a -c %{KVERREL}
%endif

%ifarch i386 i486 i586 i686 k6 k7
%post fb
/sbin/installkernel -a -c %{KVERREL}fb
%endif

%ifarch i386 i486 i586 i686 k6 k7
%post smp
/sbin/installkernel -a -c %{KVERREL}smp
%endif

%ifarch i386 i486 i586 i686 k6 k7
%post secure
/sbin/installkernel -a -c %{KVERREL}secure
%endif

%post headers
cd /usr/src
rm -f linux
ln -snf linux-%{kversion} linux

%post source
cd /usr/src
rm -f linux
ln -snf linux-%{kversion} linux
if [ -x /usr/bin/update-menus ];then
		/usr/bin/update-menus
fi

%postun headers
if [ -L /usr/src/linux ]; then 
    if [ `ls -l /usr/src/linux | awk '{ print $11 }'` = "linux-%{kversion}" ]; then
	[ $1 = 0 ] && rm -f /usr/src/linux
    fi
fi
exit 0

%postun source
if [ -L /usr/src/linux ]; then 
    if [ `ls -l /usr/src/linux | awk '{ print $11 }'` = "linux-%{kversion}" ]; then
	[ $1 = 0 ] && rm -f /usr/src/linux
    fi
fi
if [ -x /usr/bin/update-menus ];then
		/usr/bin/update-menus
fi
exit 0

%ifarch i386 i486 i586 i686 k6 k7
%post pcmcia-cs
/sbin/chkconfig --add pcmcia

%preun pcmcia-cs
if [ $1 = 0 ]; then
    /sbin/chkconfig --del pcmcia
fi
exit 0

%triggerpostun -- kernel-pcmcia-cs < 2.2.5
if [ -f /etc/rc.d/init.d/pcmcia ] ; then
    /sbin/chkconfig --add pcmcia
fi

%endif

###
### file lists
###

%files
%doc config_files/kernel-%{kversion}-%{krelease}-%{_target_cpu}.config
%defattr(-,root,root)
/boot/vmlinuz-%{KVERREL}
%ifnarch i386 i486 i586 i686 k6 k7
/boot/vmlinux-%{KVERREL}
%endif
/boot/System.map-%{KVERREL}
%dir /lib/modules
/lib/modules/%{KVERREL}/.rhkmvtag
/lib/modules/%{KVERREL}/block
/lib/modules/%{KVERREL}/cdrom
/lib/modules/%{KVERREL}/fs
/lib/modules/%{KVERREL}/ipv4
/lib/modules/%{KVERREL}/misc
/lib/modules/%{KVERREL}/net
/lib/modules/%{KVERREL}/scsi
%ifarch i386 i486 i586 i686 k6 k7
/lib/modules/%{KVERREL}/pcmcia
/lib/modules/%{KVERREL}/usb
%endif

%ifarch i386 i486 i586 k6 k7
%files fb
%defattr(-,root,root)
%doc config_files/kernel-%{kversion}-%{krelease}-%{_target_cpu}-fb.config
/boot/vmlinuz-%{KVERREL}fb
/boot/System.map-%{KVERREL}fb
%dir /lib/modules/
/lib/modules/%{KVERREL}fb/.rhkmvtag
/lib/modules/%{KVERREL}fb/block
/lib/modules/%{KVERREL}fb/cdrom
/lib/modules/%{KVERREL}fb/fs
/lib/modules/%{KVERREL}fb/ipv4
/lib/modules/%{KVERREL}fb/misc/
/lib/modules/%{KVERREL}fb/net
/lib/modules/%{KVERREL}fb/pcmcia
/lib/modules/%{KVERREL}fb/usb
/lib/modules/%{KVERREL}fb/scsi
%endif

%files secure
%defattr(-,root,root)
%doc config_files/kernel-%{kversion}-%{krelease}-%{_target_cpu}-secure.config
/boot/vmlinuz-%{KVERREL}secure
%ifnarch i386 i486 i586  k6 k7
/boot/vmlinux-%{KVERREL}
%endif
/boot/System.map-%{KVERREL}secure
%dir /lib/modules/
/lib/modules/%{KVERREL}secure/.rhkmvtag
/lib/modules/%{KVERREL}secure/block
/lib/modules/%{KVERREL}secure/cdrom
/lib/modules/%{KVERREL}secure/fs
/lib/modules/%{KVERREL}secure/ipv4
/lib/modules/%{KVERREL}secure/misc
/lib/modules/%{KVERREL}secure/net
/lib/modules/%{KVERREL}secure/scsi
%ifarch i386 i486 i586 i686 k6 k7
/lib/modules/%{KVERREL}secure/pcmcia
/lib/modules/%{KVERREL}secure/usb
%endif

%ifnarch k6 k7
%files smp
%defattr(-,root,root)
%doc config_files/kernel-%{kversion}-%{krelease}-%{_target_cpu}-smp.config
/boot/vmlinuz-%{KVERREL}smp
%ifnarch i386 i486 i586
/boot/vmlinux-%{KVERREL}
%endif
/boot/System.map-%{KVERREL}smp
%dir /lib/modules/
/lib/modules/%{KVERREL}smp/.rhkmvtag
/lib/modules/%{KVERREL}smp/block
/lib/modules/%{KVERREL}smp/cdrom
/lib/modules/%{KVERREL}smp/fs
/lib/modules/%{KVERREL}smp/ipv4
/lib/modules/%{KVERREL}smp/misc
/lib/modules/%{KVERREL}smp/net
/lib/modules/%{KVERREL}smp/scsi
%ifarch i386 i486 i586 i686 k6 k7
/lib/modules/%{KVERREL}smp/pcmcia
/lib/modules/%{KVERREL}smp/usb
%endif
%endif

%files source
%defattr(-,root,root)
/usr/lib/menu/*
/usr/share/icons/mini/*.xpm
/usr/src/linux-%{kversion}/COPYING
/usr/src/linux-%{kversion}/CREDITS
/usr/src/linux-%{kversion}/Documentation
/usr/src/linux-%{kversion}/MAINTAINERS
/usr/src/linux-%{kversion}/Makefile
/usr/src/linux-%{kversion}/README
/usr/src/linux-%{kversion}/REPORTING-BUGS
/usr/src/linux-%{kversion}/Rules.make
/usr/src/linux-%{kversion}/drivers
/usr/src/linux-%{kversion}/fs
/usr/src/linux-%{kversion}/init
/usr/src/linux-%{kversion}/ipc
/usr/src/linux-%{kversion}/kernel
/usr/src/linux-%{kversion}/lib
/usr/src/linux-%{kversion}/mm
/usr/src/linux-%{kversion}/modules
/usr/src/linux-%{kversion}/net
/usr/src/linux-%{kversion}/scripts
/usr/src/linux-%{kversion}/arch/%{_arch}
%ifarch sparc sparc64
/usr/src/linux-%{kversion}/arch/sparc64
%endif

%ifarch i386 i486 i586  k6 k7
/usr/src/linux-%{kversion}/ibcs
/usr/src/linux-%{kversion}/pcmcia-cs-%{pcmciaver}
/usr/src/drivers/emu10k1
%endif

%files utils
%defattr(-,root,root)
/usr/sbin/ksymoops
/usr/man/man8/ksymoops.8.bz2

%files headers
%defattr(-,root,root)
%dir /usr/src/linux-%{kversion}
%ifarch sparc sparc64
/usr/src/linux-%{kversion}/include/asm-sparc
/usr/src/linux-%{kversion}/include/asm-sparc64
/usr/include/asm-sparc
/usr/include/asm-sparc64
%else
/usr/src/linux-%{kversion}/include/asm-%{_arch}
%endif
/usr/src/linux-%{kversion}/include/asm
/usr/src/linux-%{kversion}/include/asm-generic
/usr/src/linux-%{kversion}/include/linux
/usr/src/linux-%{kversion}/include/net
/usr/src/linux-%{kversion}/include/scsi
/usr/src/linux-%{kversion}/include/video
%ifarch alpha sparc sparc64
/usr/src/linux-%{kversion}/include/math-emu
%endif
/usr/include/asm
/usr/include/linux
/usr/src/linux-%{kversion}/README.kernel-sources
/boot/kernel.h

%files doc
%defattr(-,root,root)
%doc Documentation/*

%ifarch i386 i486 i586 i686 k6 k7
%files pcmcia-cs
%defattr(-,root,root)
%doc pcmcia-cs-%{pcmciaver}/doc/PCMCIA-HOWTO 
%doc pcmcia-cs-%{pcmciaver}/doc/PCMCIA-PROG
%doc pcmcia-cs-%{pcmciaver}/SUPPORTED.CARDS 
%doc pcmcia-cs-%{pcmciaver}/CHANGES 
%doc pcmcia-cs-%{pcmciaver}/COPYING 
%doc pcmcia-cs-%{pcmciaver}/README
%attr(755,root,root) /sbin/cardctl
/sbin/cardmgr
/sbin/ftl_check
/sbin/ftl_format
/sbin/ifport
/sbin/ifuser
/sbin/pcinitrd
/sbin/probe
/sbin/scsi_info
/sbin/ide_info
/usr/man/*/*
%config /etc/rc.d/init.d/pcmcia
%config /etc/sysconfig/pcmcia
%dir /etc/pcmcia
#/etc/pcmcia/cdrom
/etc/pcmcia/config
/etc/pcmcia/ftl
/etc/pcmcia/ide
/etc/pcmcia/memory
/etc/pcmcia/network
/etc/pcmcia/scsi
/etc/pcmcia/serial
/etc/pcmcia/shared
/etc/pcmcia/cis
%config /etc/pcmcia/config.opts
%config /etc/pcmcia/ftl.opts
%config /etc/pcmcia/ide.opts
%config /etc/pcmcia/memory.opts
%config /etc/pcmcia/scsi.opts
%config /etc/pcmcia/serial.opts
%endif

%ifarch i386 i486 i586 i686 k6 k7
%files ibcs
%defattr(-,root,root)
%doc ibcs/{README,RELEASE,CREDITS,Doc}
/usr/man/man9/iBCS.9.bz2
/dev/MAKEDEV.ibcs
/dev/inet
/dev/socksys
/dev/nfsd
/dev/X0R
/dev/spx
/dev/arp
/dev/egp
/dev/ggp
/dev/icmp
/dev/idp
/dev/ip
/dev/ipip
/dev/pup
/dev/rawip
/dev/rip
/dev/tcp
/dev/udp
%endif

%ifarch i386 i486 i586 i686 k6 k7
%files -n alsa
%defattr(-,root,root)
%doc alsa-doc/*
/lib/modules/%{KVERREL}/alsa/
/lib/modules/%{KVERREL}fb/alsa/
/lib/modules/%{KVERREL}smp/alsa/
%files -n alsa-source
%defattr(-,root,root)
/usr/src/drivers/alsa-driver-%{alsaver}
%endif

%ifarch i386 i486 i586 i686 k6 k7
%files -n reiserfs-utils
%defattr(-,root,root)
/sbin/*reiserfs*
%endif

%changelog
* Wed May 10 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.2.15-4mdk
- Fix pcmcia again :[

* Tue May  9 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.2.15-3mdk
- Fix pcmcia.
- Correct .config with UDMA66.
- Fix version with reiserfs.

* Sun May  7 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.2.15-2mdk
- Upgrade usb backport from 2.3.99-pre7-1.
- Fix Bigmem support.

* Thu May  4 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.2.15-1mdk
- 2.2.15 final.

* Thu May  4 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.2.15-0.30mdk
- Fix pcmcia.
- Don't compile smp for fb.

* Wed May  3 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.2.15-0.29mdk
- Fix logofb.
- Fix i810.
- Fix menu.
- Add by default the ide patchs for u66 in kernel.

* Wed Apr 26 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.2.15-0.28mdk
- Upgrade the usb backport from 2.3.99-pre6.
- Build alsa with --with-oss=y --with-sequencer=y.
- Upgrade aic7xxx driver to 5.1.29.

* Tue Apr 25 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.2.15-0.27mdk
- Add menu entry for make xconfig and icons.
- Fix xconfig with newagpdist patch.
- linkx install.sh to installkernel from initscripts.
- Add missing prereq.
- Add %defattr.
- better logo from ln.

* Tue Apr 25 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.2.15-0.26mdk
- Fix alpha compilation.
- Make scsi of alpha as modules.
- 2.2.15-pre20:
		fix an NFS bug in pty code introduced in 2.2.15pre19.

* Sun Apr 23 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.2.15-0.25mdk
- Add alsa drivers to alsa package for all arch.
- Add Readme for supermount.
- supermount-0.1.5.
- ipvs-0.9.11.
- new and powerfull installkernel, can add entry to grub and lilo.
- Use installkernel in %post (and depend Prereq).
- Fix usbdevfs backport (no active by default).

* Thu Apr 20 2000 Frederic Lepied <flepied@mandrakesoft.com> 2.2.15-0.24mdk
- fix pcmcia modules.

* Wed Apr 19 2000 Frederic Lepied <flepied@mandrakesoft.com> 2.2.15-0.23mdk
- fsck.reiserfs points to /bin/true.
- new logos.

* Tue Apr 18 2000 Frederic Lepied <flepied@mandrakesoft.com> 2.2.15-0.22mdk
- added i810 driver from XFree86.

* Sun Apr 16 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.2.15-0.21mdk
- 2.2.15pre19.
- Alsa-0.5.7.
- pcmcia-3.1.14.
- Don't ask question when using -f with mkreiserfs.
- Apply suse patch for symlinks with reiserfs.

* Thu Apr  6 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.2.15-0.20mdk
- Fix usb-storage backport oops.
- alsa-0.5.7.
- Really apply patch :\.

* Wed Apr  5 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.2.15-0.19mdk
- reAdd patch to don't check conunt on CD_DO_IOTCL.
- reAdd patch to redirect the I/O error of supermount to syslog.

* Sat Apr  1 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.2.15-0.18mdk
- Adjust groups.
- Add reiserfs support.
- Alsa-0.5.6.
- pcmcia-cs-3.1.13.
- 2.2.15pre17.


* Fri Mar 24 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.2.15-0.17mdk
- Add security patch on ipmasquerading and ftp (bugtraq).
- Compile sparc64 in sparc32 (ask sparc team).
- Add lot of Requires for (alsa|kernel)-source.
- Don't set CONFIG_APM_REAL_MODE_POWER_OFF (break 95% of x86 arch).
- BuildAlsa for smp and fb.
- Don't use CPIA_PP from usb backport but use the official one.
- 2.2.15pre15.

* Mon Mar 13 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.2.15-0.16mdk
- Add UDF patch.

* Sun Mar 12 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.2.15-0.15mdk
- Fix emu10k1 clean-up.
- Don't compile CPIO_PP with usb backport.
- 2.2.15pre14

* Thu Mar  9 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.2.15-0.14mdk
- Fix typo in Requires :\.

* Thu Mar  9 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.2.15-0.13mdk
- Alsa package requires modutils >= 2.3.9.
- Alsa Obsoletes alsa-drivers (titi).
- Add usb backport from 2.3 to 2.2 (and even get working).
- Put usb modules in /lib/modules/*/usb (modutils 2.3.9 handle nicely).

* Mon Mar  6 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.2.15-0.12mdk
- Build Emu10k1 like the old and ugly time.

* Sat Mar  4 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.2.15-0.11mdk
- Fix files conflict when installing with rpm -i multiples kernel.
- 2.2.15pre13
- Fix requires for alsa-source.
- Fix bad macros (rpm bug ?).
- Alsa-0.5.5.
- 2.2.15pre12.

* Thu Feb 24 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.2.15-0.9mdk
- 2.2.15pre10.
- supermount 0.1.4a.
- Remove bigmem (buggy).
- Move modules to alsa to his own package compile only for kernel
  package and add a alsa-source package.

* Wed Feb 23 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.2.15-0.8mdk
- Config file as %doc of each kind of package.
- Version 2 of openwall patchs.
- Fix Provides lines (Axalon).
- 2.2.15pre9.
- Fix various ksymoops weirdness.
- Revert raid1 stuff from pre? kernel (we use the new Raid style).
- Merge with RedHat patchs (74 patchs mostly backport).
- Pcmcia-3.1.11.
- Alsa-0.5.3.

* Fri Jan 28 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.2.15-0.6mdk
- Renamed release for the new name scheme.
- 2.2.15pre5.
- Fix initrd for alpha.
- Add modifed logo.h for sparc.

* Wed Jan 26 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.2.15-5mdk
- Fix bad statfs with supermount (author).
- Update of Sblive drivers from CVS.

* Mon Jan 24 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.2.15-4mdk
- Disable supermount for sparc.
- Remove ptmodem drivers.
- Remove modules.dep in %pre.
- Disable UMSDOS.
- 2.2.15pre4.
- Alsa 0.5.1.
- Get finally work the fu*** sparc kernel.

* Tue Jan 18 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.2.15-2mdk
- 2.2.15pre3.

* Sun Jan 16 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.2.15-1mdk
- 2.2.15pre2.
- Remove eepro patch (in 2.2.15pre2).
- Upgrade ide patchs (don't apply it just here for future).
- pcmcia 16-JAN-00.
- fix sparc compilation and config files.

* Wed Jan 12 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.2.14-16mdk
- Remove module-info
- pcmcia 10-JAN-00.
- Make the rpm friendly-build for sparc(64) and alpha.
- Merge with last rh patches.
- ksysmoops 2.3.3.
- Spec cleanup.
- Last OpenWall patches.

* Tue Jan  4 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.2.14-15mdk
- 2.2.14 final.

* Mon Jan  3 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.2.14-14mdk
- Fix pcmcia permissions (thnks rpmlint).
